Bug 440897 - GFS: gfs_fsck should repair gfs_grow corruption (see bug #436383)
GFS: gfs_fsck should repair gfs_grow corruption (see bug #436383)
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: gfs-utils (Show other bugs)
5.2
All Linux
high Severity high
: rc
: ---
Assigned To: Robert Peterson
GFS Bugs
:
Depends On: 440896
Blocks:
  Show dependency treegraph
 
Reported: 2008-04-04 12:51 EDT by Robert Peterson
Modified: 2010-01-11 22:34 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-20 15:32:45 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Patch to fix the problem (3.71 KB, patch)
2008-04-13 11:37 EDT, Robert Peterson
no flags Details | Diff

  None (edit)
Description Robert Peterson 2008-04-04 12:51:46 EDT
+++ This bug was initially created as a clone of Bug #440896 +++
This was cloned so I can crosswrite the fix to RHEL5.

Description of problem:
The problem described in bug #436383 (RHEL4) and bug #434962 (RHEL5)
introduces corruption into a gfs file system.  Today's gfs_fsck is
unable to repair that damage, and I think it needs to.

Version-Release number of selected component (if applicable):
RHEL5

How reproducible:
Easily (now that I know the trick).

Steps to Reproduce:
1. Follow the steps listed in bug #436383 to corrupt a file system
2. Run gfs_fsck on the corrupt file system
  
Actual results:
gfs_fsck's resource group analysis says "(passed)" and no corruption
is detected.

[root@exxon-01 /home/bob]# gfs_fsck /dev/exxon_vg/exxon_lv 
Initializing fsck
Can't seek to last block in file system: 4309132281
Unable to determine the boundaries of the file system.

Expected results:
gfs_fsck should detect and repair the damage gracefully.

Additional info:
I've got a prototype patch that does this.  The RHEL4 version is
attached to bug #436383.  It still needs some testing.
Comment 2 Robert Peterson 2008-04-13 11:37:32 EDT
Created attachment 302272 [details]
Patch to fix the problem

This patch to gfs_fsck detects and repairs the rindex corruption caused
by gfs_grow in bug #436383.  This patch does NOT include any of the other
bugs I found and fixed in gfs_fsck related to rindex repair.  The right
thing to do is open a new bugzilla record for those fixes, which I will
do shortly.  I do have that set of fixes for gfs_fsck written, debugged,
tested and in-hand as well, but it's better to do that with a different
bugzilla record.
Comment 3 Robert Peterson 2008-04-13 12:36:37 EDT
This fix passes my hours-long "gfs_fsck_hellfire" test with flying colors.
I pushed the fix to the RHEL5, STABLE2 and master branches of the cluster
git tree.  Now I need some ack flags from the appropriate parties so I
can mark this modified.
Comment 5 Robert Peterson 2008-04-14 13:01:53 EDT
Tested on roth-01.  Changing status to modified.
Comment 8 errata-xmlrpc 2009-01-20 15:32:45 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2009-0059.html

Note You need to log in before you can comment on or make changes to this bug.